#pragma once
#include "coptcpp.idl.h"
#include "exception.h"

class PsdExpr;
class SymMatrix;

// This client implemented class showing how to wrapper SymMatrix class from copt cpp dll
class SymMatrix {
public:
  SymMatrix(Copt::ISymMatrix* mat) : m_mat(mat) {}

  int GetIdx() const
  {
    return m_mat->GetIdx();
  }
  int GetDim() const
  {
    return m_mat->GetDim();
  }

  SymMatrix operator*(double c) const
  {
    return m_mat->MultInternal(c);
  }
  SymMatrix operator+(const SymMatrix& mat) const
  {
    return m_mat->AddInternal(mat.Get(), /*sign*/ true);
  }
  SymMatrix operator-(const SymMatrix& mat) const
  {
    return m_mat->AddInternal(mat.Get(), /*sign*/ false);
  }

  friend SymMatrix operator*(double c, const SymMatrix& mat)
  {
    return mat * c;
  }

  Copt::ISymMatrix* Get() const
  {
    return &(*m_mat);
  }

private:
  std::shared_ptr<Copt::ISymMatrix> m_mat;
};
